import {
  PropertyKeyType,
} from '@overflow/commons/core/type';

export interface Annotation {
  classDecorator?<TFunction extends Function>(target: TFunction): TFunction | void;
  propertyDecorator?(target: Object, propertyKey: PropertyKeyType): void;
  methodDecorator?<T>(target: Object, propertyKey: PropertyKeyType,
                      descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void;
  parameterDecorator?(target: Object, propertyKey: PropertyKeyType, parameterIndex: number): void;
}

export abstract class Annotation {
}

export default Annotation;
