import {
  Action,
} from './action';

// API Action Type
export type ASYNC_REQUEST = '@overflow/commons/async/REQUEST';
export const ASYNC_REQUEST: ASYNC_REQUEST = '@overflow/commons/async/REQUEST';

export interface AsyncRequestPayload {
  method: string;
  params?: any[];
}

export type asyncRequestActions = (method: string, ...params: any[]) => Action<AsyncRequestPayload>;
export const asyncRequestActions: asyncRequestActions = (method: string, ...params: any[]): Action<AsyncRequestPayload> => {
  return {
      type: ASYNC_REQUEST,
      payload: {
        method: method,
        params: params,
      },
    };
};
