import {
  Action,
} from './action';

// REST Action Type
export type REST_REQUEST = '@overflow/commons/rest/REQUEST';
export const REST_REQUEST: REST_REQUEST = '@overflow/commons/rest/REQUEST';

export interface RESTRequestPayload {
  entry: string;
  params?: any[];
}

export type restRequestActions = (entry: string, ...params: any[]) => Action<RESTRequestPayload>;
export const restRequestActions: restRequestActions = (entry: string, ...params: any[]): Action<RESTRequestPayload> => {
  return {
      type: REST_REQUEST,
      payload: {
        entry: entry,
        params: params,
      },
    };
};
