import * as TypeUtil from '@overflow/commons/core/type/util';
import {
  Annotation,
  Decorator,
} from '@overflow/commons/decorator';



export interface ReducerAnnotationAttributes {
  name: string;
}

export class ReducerAnnotation extends Annotation {
  public readonly attributes: ReducerAnnotationAttributes;

  public constructor(name: string | ReducerAnnotationAttributes) {
    super();
    if (TypeUtil.isString(name)) {
      this.attributes = {
        name: <string>name,
      };
    } else {
      this.attributes = <ReducerAnnotationAttributes>name;
    }
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    console.log('Reducer');
  }
}

export const Reducer = Decorator.create(ReducerAnnotation);
