import * as TypeUtil from '@overflow/commons/core/type/util';
import {
  Annotation,
  Decorator,
} from '@overflow/commons/decorator';
import { PropertyKeyType } from '@overflow/commons/core/type';

export interface RestAPIAnnotationAttributes {
  entryPath: string;
}

export class RestAPIAnnotation extends Annotation {
  public readonly attributes: RestAPIAnnotationAttributes;

  public constructor(entryPath: string | RestAPIAnnotationAttributes) {
    super();
    if (TypeUtil.isString(entryPath)) {
      this.attributes = {
        entryPath: <string>entryPath,
      };
    } else {
      this.attributes = <RestAPIAnnotationAttributes>entryPath;
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('RestAPI');
  }
}

export const RestAPI = Decorator.create(RestAPIAnnotation);
