import * as TypeUtil from '@overflow/commons/core/type/util';
import {
  Annotation,
  Decorator,
} from '@overflow/commons/decorator';
import { PropertyKeyType } from '@overflow/commons/core/type';

export interface RpcAPIAnnotationAttributes {
  method: string;
}

export class RpcAPIAnnotation extends Annotation {
  public readonly attributes: RpcAPIAnnotationAttributes;

  public constructor(method: string | RpcAPIAnnotationAttributes) {
    super();
    if (TypeUtil.isString(method)) {
      this.attributes = {
        method: <string>method,
      };
    } else {
      this.attributes = <RpcAPIAnnotationAttributes>method;
    }
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('RestAPI');
  }
}

export const RpcAPI = Decorator.create(RpcAPIAnnotation);
